import React from 'react';
import { CreateAccountScreenProps } from './types';
/**
 * Component that renders a screen for the user to enter their email address to start the
 * account creation process.
 *
 * @param {CreateAccountScreenProps} props - props of CreateAccountScreen base component
 *
 * @category Component
 */
export declare const CreateAccountScreenBase: React.FC<React.PropsWithChildren<CreateAccountScreenProps & {
    inputRef?: any;
}>>;
