import React from 'react';
import { CreatePasswordScreenProps } from './types';
/**
 * The component renders a screen with the password and confirm password field for creating a new password.
 *
 * @param {CreatePasswordScreenProps} props - props of CreatePasswordScreen base component
 *
 * @category Component
 */
export declare const CreatePasswordScreenBase: React.FC<React.PropsWithChildren<CreatePasswordScreenProps>>;
