import React from 'react';
import { EulaScreenProps } from './types';
/**
 * Component that renders a screen displaying the EULA and requests acceptance via a checkbox.
 *
 * @param {EulaScreenProps} props - props of EUlA screen base component
 *
 * @category Component
 */
export declare const EulaScreenBase: React.FC<EulaScreenProps>;
