import React from 'react';
import { SuccessScreenProps } from '../SuccessScreen';
/**
 * Full Screen component that renders a Success Screen for the accounts which are already exists in the records
 *
 * @param {SuccessScreenProps} props - props of SuccessScreen
 *
 * @category Component
 */
export declare const ExistingAccountSuccessScreen: React.FC<SuccessScreenProps>;
