import React from 'react';
import { LoginScreenProps } from './types';
/**
 * Component that renders a login screen that prompts a user to enter a username and password to login.
 *
 * @param {LoginScreenProps} props - props of LoginScreen
 *
 * @category Component
 */
export declare const LoginScreen: React.FC<React.PropsWithChildren<LoginScreenProps>>;
