import React from 'react';
import { ErrorManagerProps } from './types';
/**
 * Component that manages the display of error messages. Can be configured to display a dialog, a message box, or neither.
 *
 * @param {ErrorManagerProps} props - props of errorManager component
 *
 * @category Component
 */
declare const ErrorManager: React.FC<ErrorManagerProps>;
export default ErrorManager;
