import { ErrorMessageBoxProps } from './types';
/**
 * Component that renders a basic message box with an error message and a configurable dismiss button.
 *
 * @param {ErrorMessageBoxProps} props - props of errorMessageBox component
 *
 * @category Component
 */
declare const ErrorMessageBox: (props: ErrorMessageBoxProps) => JSX.Element;
export default ErrorMessageBox;
